import pypsa
import matplotlib.pyplot as plt
import numpy as np
import scipy.optimize

import networkx as nx
from random import randint
import matplotlib
import matplotlib.gridspec as gridspec
from matplotlib.ticker import NullFormatter
from itertools import groupby

def LoadSpace(x, y,Lavl,LBx,LBy):
  ff=np.empty([len(x),len(x[1])])
  dx=x[0,1]-x[0,0]
  dy=y[1,0]-y[0,0]
  maxloadcell=0
  i = 0
  while i < len(x):
    j = 0
    while j < len(x[1]):
      loadcell=0
      k=0
      while k < len(LBx):
        if LBx[k]>x[i,j] and LBx[k]<x[i,j]+dx and LBy[k]>y[i,j] and LBy[k]<y[i,j]+dy:
          loadcell=loadcell+Lavl[k]
        k = k + 1
      ff[i].flat[j] = loadcell
      maxloadcell=max(maxloadcell,loadcell)
      j = j + 1
    i = i + 1
  return ff,maxloadcell

#Einlesen des jeweiligen Netzwerkes
#n = pypsa.Network('./base.nc')
n = pypsa.Network('./elec.nc')

#print(len(n.lines[n.lines.bus0 == '1622'][n.lines.v_nom == 220]) + len(n.lines[n.lines.bus1 == '1622'][n.lines.v_nom == 220]))

#a=[]
#for bus in n.buses.index.values:
#    a.append(len(n.lines[n.lines.bus0 == bus][n.lines.v_nom == 220])+len(n.lines[n.lines.bus1 == bus][n.lines.v_nom == 220]))
#a=np.array(a)
#print(sum(a == 0))

#Darstellen der Verteilungsfunktion der Knotengrade
#hist=np.histogram(a, bins=range(11))
#plt.scatter(hist[1][2:11],hist[0][1:])
#plt.show()

#
nullfmt = NullFormatter()  # Keine Labels im Netzwerkplot
#plot settings
params = {
    'figure.figsize'    : [10, 10],
    'text.usetex'       : True,
    'xtick.major.size'  : 10,
    'xtick.minor.size'  : 5,
    'ytick.major.size'  : 10,
    'ytick.minor.size'  : 5,
}
matplotlib.rcParams.update(params) 
TickLabelSize=18
TickMajorLength=15
LabelSize=18

matplotlib.rcParams.update({'font.size': 12})

#Ausgabebild, Gitterstruktur aus 4 Abbildungen 
plt.figure(0)

#Gesamtes Netzwerk darstellen
#plt.figure(figsize=(40,40))
#n.plot()
#plt.show()

#Auflistung einiger das Netzwerk bestimmender Groessen

#Knoten: 
#buses (Electrically fundamental node where x-port objects attach.)
#generators (Power generator)
#loads (PQ power consumer)
#stores, (Generic store, whose capacity may be optimised.)
#storage

#Links:
#links (Link between two buses with controllable active power)
#lines (Lines include distribution and transmission lines, overhead lines and cables.)

#Variablen der Charakterisierung der Knoten
#carriers (Energy carrier, such as AC, DC, heat, wind, PV or coal. Buses have direct carriers and Generators indicate their primary energy carriers. The Carrier can track properties relevant for global constraints, such as CO2 emissions.)

#Ausgabe einiger das Netzwerk bestimmender Groessen
#Der Netzwerk container von PyPSA beinhaltet wichtige das Netzwerk bestimmende Groessen und beinhaltet Methoden zur Analyse 
print('-------------')
print("Ausgabe der Knoten des Neztwerkes: n.buses")
#print(n.buses)
print("Anzahl der buses",len(n.buses))
#n.buses.index.values[0]
#n.buses.loc[n.buses.index.values[0]]
print('-------------')
print("Ausgabe der Knoten des Neztwerkes: n.generators")
#print(n.generators)
print("Anzahl der generators",len(n.generators))
#n.generators.index.values[0]
#n.generators.loc[n.generators.index.values[0]]
print('-------------')
print("Ausgabe der Knoten des Neztwerkes: n.loads")
#print(n.loads)
print("Anzahl der loads",len(n.loads))
#n.loads.index.values[0]
#n.loads.loc[n.loads.index.values[0]]
print('-------------')
print("Ausgabe der Knoten des Neztwerkes: n.stores")
#print(n.stores)
print("Anzahl der stores",len(n.stores))
print("Anzahl der storage",len(n.storage_units))
#n.stores.index.values[0]
#n.stores.loc[n.stores.index.values[0]]
print('-------------')
print("Ausgabe der Links des Neztwerkes: n.links")
#print(n.links)
print("Anzahl der links",len(n.links))
#n.links.index.values[0]
#n.links.loc[n.links.index.values[0]]
print('-------------')
print("Ausgabe der Links des Neztwerkes: n.lines")
#print(n.lines)
print("Anzahl der lines",len(n.lines))
#n.lines.index.values[0]
#n.lines.loc[n.lines.index.values[0]]
print('-------------')
loadbuses=list(n.loads_t.p_set.iloc[0].index)
#print(aa)


#Konstruktion des Netzwerkes in networkx (Undirected Simple Network)
NKn=len(n.buses)#Anzahl der Knoten
NLinks=len(n.links)#Anzahl der Links
NLines=len(n.lines)#Anzahl der Lines
PropPlayers=np.zeros([NKn,10])#Erzeugung einer Liste zum Speichern der Knoten/Spieler Eigenschaften
G = nx.Graph()

#Erzeugung der Knoten (buses), Knotenattribut ist die Busnummer
for k in range(0,NKn):
  G.add_node(k, bus=n.buses.index.values[k])
  PropPlayers[k].flat[0] = k #Knotennummer
  PropPlayers[k].flat[1] = n.buses.loc[n.buses.index.values[k]].x #x-Koordinate auf dem 2-D Gitter
  PropPlayers[k].flat[2] = n.buses.loc[n.buses.index.values[k]].y #y-Koordinate auf dem 2-D Gitter
  strategy=randint(0, 100)/100.0 #Zufaellige Strategienwahl (0,1)
  PropPlayers[k].flat[3] = strategy 
  PropPlayers[k].flat[4] = n.buses.index.values[k]#Busnummer
  PropPlayers[k].flat[7] = 0
  if n.buses.index.values[k] in loadbuses:
    aa=list(n.loads_t.p_set[n.buses.index.values[k]])
    PropPlayers[k].flat[7] = sum(aa)/float(len(aa))

#Erzeugung der Kanten (Links und Lines), Attribut ist type=link oder type=line
#Die Angabe welche Knotennummern die Kante hat wird ueber den der links/lines gemacht. Beispiel Link 0 verbindet die Knoten mit den folgenden Knotennummern:
#print("Link 0, bus0: ",list(n.buses.index.values).index(n.links.loc[n.links.index.values[0]].bus0))
#print("Link 0, bus1: ",list(n.buses.index.values).index(n.links.loc[n.links.index.values[0]].bus1))
for link_num in range(0,NLinks):
  link_bus0=list(n.buses.index.values).index(n.links.loc[n.links.index.values[link_num]].bus0)
  link_bus1=list(n.buses.index.values).index(n.links.loc[n.links.index.values[link_num]].bus1)
  G.add_edge(link_bus0,link_bus1, type='link')
for line_num in range(0,NLines):
  line_bus0=list(n.buses.index.values).index(n.lines.loc[n.lines.index.values[line_num]].bus0)
  line_bus1=list(n.buses.index.values).index(n.lines.loc[n.lines.index.values[line_num]].bus1)
  G.add_edge(line_bus0,line_bus1, type='line')

#G.add_node(NKn, bus=100000)
#G.add_node(NKn+1, bus=200000)
#G.add_edge(NKn,NKn+1, type='link')
#G.add_edge(NKn,NKn+1, type='line')
#print('Anzahl edges Knoten 0',G.edges([NKn]))
#print('Anzahl edges Knoten 0',G.edges([NKn+1]))
#print('Anzahl edges Knoten 0',G.edges([0]))
#print('Anzahl edges Knoten 0',G.edges([10]))
#print('Anzahl edges Knoten 0',G.edges([100]))
#print('Anzahl edges Knoten 0',G.edges([1000]))

print('Anzahl nodes EU',len(G))
#print('Anzahl nodes DE',len(G_DE))
#  if n.buses.loc[n.buses.index.values[k]].country == 'DE':
#    G_DE.add_node(kk, bus=n.buses.index.values[k])
#    kk=kk+1
list_DE=[]
list_NL=[]
list_FR=[]
list_PL=[]
list_CZ=[]
list_BE=[]
list_CH=[]
list_AT=[]
list_LU=[]
list_DK=[]
#['DE', 'PT', 'NL', 'IT', 'ES', 'IE', 'HU', 'GR', 'FR', 'AL', 'MK', 'CH', 'RO', 'BG', 'RS', 'HR', 'BA', 'ME', 'BE', 'AT', 'SK', 'CZ', 'SI', 'PL', 'LU', 'GB', 'LV', 'LT', 'DK', 'SE', 'EE', 'NO', 'FI']
for k in range(0,NKn):
  PropPlayers[k].flat[5] = len(G.edges([k]))
  if n.buses.loc[n.buses.index.values[k]].country == 'DE':
    PropPlayers[k].flat[6] = 1
    list_DE.append(k)
  if n.buses.loc[n.buses.index.values[k]].country == 'NL':
    PropPlayers[k].flat[6] = 3
    list_NL.append(k)
  if n.buses.loc[n.buses.index.values[k]].country == 'FR':
    PropPlayers[k].flat[6] = 9
    list_FR.append(k)
  if n.buses.loc[n.buses.index.values[k]].country == 'PL':
    PropPlayers[k].flat[6] = 24
    list_PL.append(k)
  if n.buses.loc[n.buses.index.values[k]].country == 'CZ':
    PropPlayers[k].flat[6] = 22
    list_CZ.append(k)
  if n.buses.loc[n.buses.index.values[k]].country == 'BE':
    PropPlayers[k].flat[6] = 14
    list_BE.append(k)
  if n.buses.loc[n.buses.index.values[k]].country == 'CH':
    PropPlayers[k].flat[6] = 12
    list_CH.append(k)
  if n.buses.loc[n.buses.index.values[k]].country == 'AT':
    PropPlayers[k].flat[6] = 20
    list_AT.append(k)
  if n.buses.loc[n.buses.index.values[k]].country == 'LU':
    PropPlayers[k].flat[6] = 25
    list_LU.append(k)
  if n.buses.loc[n.buses.index.values[k]].country == 'DK':
    PropPlayers[k].flat[6] = 29
    list_DK.append(k)
#print("list")
#print(list_DE)

#Berechnung der Liste der Knotengrade
av_deg=[]#Erzeugung einer Liste zum Speichern der gemittelten Verteilungsfunktion
degree_sequence=sorted([dd for n,dd in G.degree()],reverse=True) # degree sequence
av_deg.extend(degree_sequence) 
maxk=np.max(degree_sequence)
maxkav=np.max(av_deg)
##ax2.hist(degree_sequence,bins=range(0,int(maxk+2),1),normed=1, align="left" ,histtype='bar', color="blue", alpha=0.4)
#
num_degreeseq=[len(list(group)) for key, group in groupby(degree_sequence)]
max_degr=np.max(degree_sequence)
node_sizel=[40,40,40,40,40,35,30,20,10,5,5,5,5,5,5,5,5,5,5,5,5,5]
node_sizel=[70,70,70,70,70,60,50,40,20,10,5,5,5,5,5,5,5,5,5,5,5,5]
node_alphal=[0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9]
node_colorl=["black","red","blue","green","orange","plum","yellow","yellow","yellow","yellow","yellow","yellow"]
node_colorl=["black","black","black","black","black","black","black","black","black","black","black","black","black","black","black","black","black","black"]
node_markerl=["D","s","^","P","o","o","o","o","o","o","o","o","o","o","o","o","o","o","o","o"]
##for k in range(0,max_degr):
##  ax2.scatter(max_degr-k, 0.1, c=node_colorl[k], s=node_sizel[k] ,alpha=node_alphal[k], edgecolors='none', marker=node_markerl[k])
##  ax2.text(max_degr-k,0.13,str(num_degreeseq[k]),verticalalignment="center",horizontalalignment="center")
#print(num_degreeseq)
#print(degree_sequence[0:num_degreeseq[0]])
#print(degree_sequence[num_degreeseq[0]:sum(num_degreeseq[0:2])])
#print(sum(num_degreeseq[0:2]))
#plt.hist(degree_sequence,bins=range(0,int(maxk+2),1),normed=1, align="left" ,histtype='bar', color="blue", alpha=0.4)
#for k in range(0,max_degr):
#  plt.scatter(max_degr-k, 0.1, c=node_colorl[k], s=node_sizel[k] ,alpha=node_alphal[k], edgecolors='none', marker=node_markerl[k])
#  plt.text(max_degr-k,0.13,str(num_degreeseq[k]),verticalalignment="center",horizontalalignment="center")

#Erzeugung des Netzwerk-Bildes  
node_size=1
node_alpha=0.3
node_color="darkgray"
edge_tickness=0.1
edge_alpha=0.6
edge_color="blue"
node_text_size=9
text_font="sans-serif"
graph_pos=nx.kamada_kawai_layout(G)
#'bipartite_layout',?
#'circular_layout',
#'kamada_kawai_layout', Position nodes using Kamada-Kawai path-length cost-function: Energy-based approach: Kamada and Kawai use a spring approach with the key concept that Euclidean distance in the layout should approximate the graph-theoretic distance, i.e.the shortest path length between two nodes.
#'random_layout',
#'rescale_layout',
#'shell_layout', Knotenkreis mit edges
#'spring_layout', Position nodes using Fruchterman-Reingold force-directed algorithm of the Force-directed graph drawing: position the nodes in two-dimensional space is set so that all the edges are of more or less equal length and there are as few crossing edges as possible.
#'spectral_layout', nur Knoten
#'planar_layout', ?
#'fruchterman_reingold_layout'
#nx.draw_networkx_nodes(G,graph_pos,node_size=node_size)
#nx.draw_networkx_edges(G,graph_pos)
nx.draw_networkx_nodes(G,graph_pos,node_size=node_size,alpha=node_alpha, node_color=node_color)
nx.draw_networkx_edges(G,graph_pos,width=edge_tickness, alpha=edge_alpha,edge_color=edge_color)
#nx.draw_networkx_labels(G, graph_pos,font_size=node_text_size,font_family=text_font)

node_alpha=0.8
dsize=1
country_colorlist=["green","red","blue","sienna","orange","darkcyan","darkviolet","deeppink","peru","palegoldenrod"]
G_DE = G.subgraph(list_DE)
nx.draw_networkx_nodes(G_DE,graph_pos,node_size=node_size+dsize,alpha=node_alpha, node_color=country_colorlist[0],label=r"$\rm DE$")
G_NL = G.subgraph(list_NL)
nx.draw_networkx_nodes(G_NL,graph_pos,node_size=node_size+dsize,alpha=node_alpha, node_color=country_colorlist[1],label=r"$\rm NL$")
G_FR = G.subgraph(list_FR)
nx.draw_networkx_nodes(G_FR,graph_pos,node_size=node_size+dsize,alpha=node_alpha, node_color=country_colorlist[2],label=r"$\rm FR$")
G_PL = G.subgraph(list_PL)
nx.draw_networkx_nodes(G_PL,graph_pos,node_size=node_size+dsize,alpha=node_alpha, node_color=country_colorlist[3],label=r"$\rm PL$")
G_CZ = G.subgraph(list_CZ)
nx.draw_networkx_nodes(G_CZ,graph_pos,node_size=node_size+dsize,alpha=node_alpha, node_color=country_colorlist[4],label=r"$\rm CZ$")
G_BE = G.subgraph(list_BE)
nx.draw_networkx_nodes(G_BE,graph_pos,node_size=node_size+dsize,alpha=node_alpha, node_color=country_colorlist[5],label=r"$\rm BG$")
G_CH = G.subgraph(list_CH)
nx.draw_networkx_nodes(G_CH,graph_pos,node_size=node_size+dsize,alpha=node_alpha, node_color=country_colorlist[6],label=r"$\rm CH$")
G_AT = G.subgraph(list_AT)
nx.draw_networkx_nodes(G_AT,graph_pos,node_size=node_size+dsize,alpha=node_alpha, node_color=country_colorlist[7],label=r"$\rm AT$")
G_LU = G.subgraph(list_LU)
nx.draw_networkx_nodes(G_LU,graph_pos,node_size=node_size+dsize,alpha=node_alpha, node_color=country_colorlist[8],label=r"$\rm LU$")
G_DK = G.subgraph(list_DK)
nx.draw_networkx_nodes(G_DK,graph_pos,node_size=node_size+dsize,alpha=node_alpha, node_color=country_colorlist[9],label=r"$\rm BE$")


#print(1 in G)
#print(G.nodes[1])
#print(G.degree[1])
#print(G.edges)
print('-----------------------------')
#print(nx.get_edge_attributes(G,'type'))

#print(PropPlayers[10:20])
#print(max(PropPlayers[:][2]))
#print(min(PropPlayers[:][2]))
#print(max(PropPlayers[:][3]))
#print(min(PropPlayers[:][3]))
#print(max(PropPlayers[:][6]))
#print(min(PropPlayers[:][6]))
#print(PropPlayers[1,2])
print('-----------------------------')

MaxX=max(PropPlayers[:,1])
MinX=min(PropPlayers[:,1])
MaxY=max(PropPlayers[:,2])
MinY=min(PropPlayers[:,2])
IMaxX=int(round(MaxX)+1)
IMinX=int(round(MinX)-1)
IMaxY=int(round(MaxY)+1)
IMinY=int(round(MinY)-1)
spacepoints=150
spacepoints=20
#spaceX = np.linspace(IMinX,IMaxX, spacepoints)
#spaceY = np.linspace(IMinY, IMaxY, spacepoints)
#X, Y = np.meshgrid(spaceX, spaceY)
#print(X)
##LoadSP,plotmax=LoadSpace(X, Y,PropPlayers[:,7],PropPlayers[:,1],PropPlayers[:,2])
#print(dx)
#print(dy)
#print(plotmax)
#cmap1=plt.cm.gnuplot
#cmap1=plt.cm.gist_ncar
cmap1=plt.cm.hot
##ax3.pcolormesh(X,Y,LoadSP,shading='gouraud',vmin=0,vmax=500,cmap=cmap1)
##plt.pcolormesh(X,Y,LoadSP,shading='gouraud',vmin=0,vmax=500,cmap=cmap1)

node_sizel=[7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,5,5,5,5,5,5,5,5,5,5,5,5,5]
node_sizel=[60,60,50,50,20,10,7,5,5,5,5,5,5,5,5,5,5,5,5,5,5]
node_alphal=[0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.9,0.4,0.4,0.4,0.4]
node_colorl=["black","red","blue","green","orange","plum","yellow","yellow","yellow","yellow","yellow","yellow"]
node_colorl=["black","black","black","black","black","black","black","black","black","black","black","black","black","black","black","black","black","black"]
#node_colorl=["grey","grey","grey","grey","grey","grey","grey","grey","grey","grey","grey","grey","grey","grey","grey","grey","grey","grey","grey","grey"]
node_markerl=["D","s","^","P","o","o","o","o","o","o","o","o","o","o","o","o","o","o","o","o"]
aatime=72
edge_tickness=0.1
curve_tickness=0.5
#avloadsorted=sorted(PropPlayers[:,7], reverse=True)
iloadend=0
#for k in range(0,NKn):
#  if avloadsorted[k] > 0:
#    iloadend=k
#  node_colornew="black"
#  if k in list_DE:
#    node_colornew=country_colorlist[0]
#  if k in list_NL:
#    node_colornew=country_colorlist[1]
#  if k in list_FR:
#    node_colornew=country_colorlist[2]
#  if k in list_PL:
#    node_colornew=country_colorlist[3]
#  if k in list_CZ:
#    node_colornew=country_colorlist[4]
#  if k in list_BE:
#    node_colornew=country_colorlist[5]
#  if k in list_CH:
#    node_colornew=country_colorlist[6]
#  if k in list_AT:
#    node_colornew=country_colorlist[7]
#  if k in list_LU:
#    node_colornew=country_colorlist[8]
#  if k in list_DK:
#    node_colornew=country_colorlist[9]
#  bb=list(G.neighbors(k))
#  if PropPlayers[k,5] == 9:
#    plt.scatter(PropPlayers[k,1], PropPlayers[k,2], c=node_colornew, s=node_sizel[0] ,alpha=node_alphal[0], edgecolors='none', marker=node_markerl[0])
#    aaload=list(n.loads_t.p_set[str(int(PropPlayers[k,4]))])
#    ax1.plot(aaload[0:aatime],c=node_colorl[0],linewidth=curve_tickness)
#    ax1.scatter(-0.5,aaload[0], c=node_colorl[0], s=node_sizel[0] ,alpha=node_alphal[0], edgecolors='none', marker=node_markerl[0])
#    for j in bb:
#      plt.plot([PropPlayers[k,1],PropPlayers[j,1]],[PropPlayers[k,2],PropPlayers[j,2]], linewidth=edge_tickness, c=node_colornew, alpha=edge_alpha)
#  if PropPlayers[k,5] == 8:
#    plt.scatter(PropPlayers[k,1], PropPlayers[k,2], c=node_colornew, s=node_sizel[1] ,alpha=node_alphal[1], edgecolors='none', marker=node_markerl[1])
#    if int(PropPlayers[k,4]) != 3735:
#      aaload=list(n.loads_t.p_set[str(int(PropPlayers[k,4]))])
#      ax1.plot(aaload[0:aatime],c=node_colorl[1],linewidth=curve_tickness)
#      ax1.scatter(-0.5,aaload[0], c=node_colorl[1], s=node_sizel[1] ,alpha=node_alphal[1], edgecolors='none', marker=node_markerl[1])
#    for j in bb:
#      plt.plot([PropPlayers[k,1],PropPlayers[j,1]],[PropPlayers[k,2],PropPlayers[j,2]], linewidth=edge_tickness, c=node_colornew, alpha=edge_alpha)
#  if PropPlayers[k,5] == 7:
#    plt.scatter(PropPlayers[k,1], PropPlayers[k,2], c=node_colornew, s=node_sizel[2] ,alpha=node_alphal[2], edgecolors='none', marker=node_markerl[2])
#    if int(PropPlayers[k,4]) != 2605 and int(PropPlayers[k,4]) != 3733:
#      aaload=list(n.loads_t.p_set[str(int(PropPlayers[k,4]))])
#      ax1.plot(aaload[0:aatime],c=node_colorl[2],linewidth=curve_tickness)
#      ax1.scatter(-0.5,aaload[0], c=node_colorl[2], s=node_sizel[2] ,alpha=node_alphal[2], edgecolors='none', marker=node_markerl[2])
#    for j in bb:
#      plt.plot([PropPlayers[k,1],PropPlayers[j,1]],[PropPlayers[k,2],PropPlayers[j,2]], linewidth=edge_tickness, c=node_colornew, alpha=edge_alpha)
#  if PropPlayers[k,5] == 6:
#    plt.scatter(PropPlayers[k,1], PropPlayers[k,2], c=node_colornew, s=node_sizel[3] ,alpha=node_alphal[3], edgecolors='none', marker=node_markerl[3])
#    for j in bb:
#      plt.plot([PropPlayers[k,1],PropPlayers[j,1]],[PropPlayers[k,2],PropPlayers[j,2]], linewidth=edge_tickness, c=node_colornew, alpha=edge_alpha)
#  if PropPlayers[k,5] == 5:
#    plt.scatter(PropPlayers[k,1], PropPlayers[k,2], c=node_colornew, s=node_sizel[4] ,alpha=node_alphal[4], edgecolors='none', marker=node_markerl[4])
#    for j in bb:
#      plt.plot([PropPlayers[k,1],PropPlayers[j,1]],[PropPlayers[k,2],PropPlayers[j,2]], linewidth=edge_tickness, c=node_colornew, alpha=edge_alpha)
#  if PropPlayers[k,5] == 4:
#    plt.scatter(PropPlayers[k,1], PropPlayers[k,2], c=node_colornew, s=node_sizel[5] ,alpha=node_alphal[5], edgecolors='none', marker=node_markerl[5])
#    for j in bb:
#      plt.plot([PropPlayers[k,1],PropPlayers[j,1]],[PropPlayers[k,2],PropPlayers[j,2]], linewidth=edge_tickness, c=node_colornew, alpha=edge_alpha)
#  if PropPlayers[k,5] == 3:
#    plt.scatter(PropPlayers[k,1], PropPlayers[k,2], c=node_colornew, s=node_sizel[6] ,alpha=node_alphal[6], edgecolors='none', marker=node_markerl[6])
#    for j in bb:
#      plt.plot([PropPlayers[k,1],PropPlayers[j,1]],[PropPlayers[k,2],PropPlayers[j,2]], linewidth=edge_tickness, c=node_colornew, alpha=edge_alpha)
#  if PropPlayers[k,5] == 2:
#    plt.scatter(PropPlayers[k,1], PropPlayers[k,2], c=node_colornew, s=node_sizel[7] ,alpha=node_alphal[7], edgecolors='none', marker=node_markerl[7])
#    for j in bb:
#      plt.plot([PropPlayers[k,1],PropPlayers[j,1]],[PropPlayers[k,2],PropPlayers[j,2]], linewidth=edge_tickness, c=node_colornew, alpha=edge_alpha)
#  if PropPlayers[k,5] == 1:
#    plt.scatter(PropPlayers[k,1], PropPlayers[k,2], c=node_colornew, s=node_sizel[8] ,alpha=node_alphal[8], edgecolors='none', marker=node_markerl[8])
#    for j in bb:
#      plt.plot([PropPlayers[k,1],PropPlayers[j,1]],[PropPlayers[k,2],PropPlayers[j,2]], linewidth=edge_tickness, c=node_colornew, alpha=edge_alpha)

#############################Loads
#aaload=list(n.loads_t.p_set['1296'])
#aaloadt=range(0,len(aaload))
#aatime=72
#print(len(aaload))
#print(aaload[0:10])
#ax1.plot(aaloadt[0:aatime],aaload[0:aatime],color="red")


#ax1.plot(avloadsorted,c="black",linewidth=curve_tickness)
#print(avloadsorted[0:iloadend+1])

#ax1.hist(np.log10(avloadsorted[0:iloadend+1]),50, density=True, color="blue", alpha=0.4)
##ax1.hist(avloadsorted[0:iloadend+1],50, density=False, color="blue", alpha=0.4)





#Achsenbeschriftung
##ax2.set_ylabel(r'$\rm P(k)$')
##ax2.set_xlim(0,maxkav+2)
##ax2.set_ylim(-0.001,0.33)
#ax1.set_ylim(-10,260)
#ax1.set_ylabel(r'$\rm Loads(t\,[h])$')

#ax1.set_xlim(0,3.3)
##ax1.set_ylabel(r'$\rm N(loads\,[MW/a])$')
##ax1.set_yscale('log')

##ax4.legend(shadow=False, frameon=False,ncol=1, fontsize=8,loc='upper right')

#plt.ylabel(r'$\rm P(k)$',size=LabelSize)
#plt.xlim(0,maxkav+2)
#plt.ylim(-0.001,0.33)

#plt.xlim(0,20)
#plt.ylim(40,60)
#plt.aspect(1.0)

plt.legend(shadow=False, frameon=False,ncol=1, fontsize=10,loc='upper right')

#plt.minorticks_on()
#plt.tick_params(labelsize=TickLabelSize,size=TickMajorLength)
#plt.tick_params('both', length=6, width=0.8, which='major')
#plt.tick_params('both', length=3, width=0.3, which='minor')

saveFig="./pic3.jpg"
plt.savefig(saveFig, dpi=500,bbox_inches="tight",pad_inches=0.05,format="jpg")
saveFig="./pic3.pdf"
plt.savefig(saveFig,bbox_inches="tight",pad_inches=0.05,format="pdf")

plt.show()
